#! /bin/sh
###################### mount partition

if [ ! -d "/usr/local/data/tmp" ];then
	rm -rf /usr/local/data/tmp
    mkdir /usr/local/data/tmp
fi
mount tmpfs /usr/local/data/tmp -t tmpfs -o size=12m

if [ -f "/usr/local/data/.macbak" ];then
	if [ x$(fw_printenv ethaddr | awk -F'=' '{print $2}') == x"00:01:02:03:04:05" ];then
		MAC=$(cat /usr/local/data/.macbak)
		fw_setenv ethaddr ${MAC}
		if [ ! x$(fw_printenv ethaddr | awk -F'=' '{print $2}') == x"00:01:02:03:04:05" ];then
			echo -e "\033[31;1methaddr lost and recovery succeed\033[0m"
			reboot
		fi
	fi
fi

###################### if notstartapp env
notstartflag=`fw_printenv notstartapp`
if [ "$notstartflag" = 'notstartapp=1' ]; then
	exit 0
fi


##################### update kernel 
if [ -f "/usr/local/data/upgrade/app.tar.gz" ]; then
	UPDATE_APP_FLAG=1
else
	UPDATE_APP_FLAG=0
fi

if [ -f "/usr/local/data/upgrade/rootfs_list.tar.gz" ]; then
	UPDATE_ROOTFS_FLAG=1
else
	UPDATE_ROOTFS_FLAG=0
fi

if [ -f "/usr/local/data/upgrade/res.tar.gz" ]; then
	UPDATE_RES_FLAG=1
else
	UPDATE_RES_FLAG=0
fi

if [ -f "/usr/local/data/upgrade/config.tar.gz" ]; then
	UPDATE_CONFIG_FLAG=1
else
	UPDATE_CONFIG_FLAG=0
fi

max_log_mumsize=102400
upgrade_log_file=/usr/local/data/upgrade_log_file
log_actualsize=$(wc -c <"$upgrade_log_file")
if [ $log_actualsize -ge $max_log_mumsize ]; then
	rm $upgrade_log_file
fi

if [ ! -f "/usr/local/atcom_version.ko" ];then
	mount -o rw,remount /
	cp /usr/local/app/driver/atcom_version.ko /usr/local/
	cp /usr/local/app/driver/atcom_lcd.ko /usr/local/
	mount -o ro,remount /
fi

if [ 1 -eq $UPDATE_APP_FLAG ] || [ 1 -eq $UPDATE_ROOTFS_FLAG ] || [ 1 -eq $UPDATE_RES_FLAG ] || [ 1 -eq $UPDATE_CONFIG_FLAG ]; then
	echo "show update window"
	mount  -o  rw,remount  /
	insmod /usr/local/atcom_version.ko
	insmod /usr/local/atcom_lcd.ko
	cp /usr/local/data/show_lcd_upgrade /usr/local/data/upgrade_fsync /tmp/
	/tmp/show_lcd_upgrade
fi

if [ 1 -eq $UPDATE_ROOTFS_FLAG ];then
	mv /usr/local/data/upgrade/rootfs_list.tar.gz /usr/local/data/tmp/ >> $upgrade_log_file 2>&1
	md5sum /usr/local/data/tmp/rootfs_list.tar.gz >> $upgrade_log_file
	tar zxvf /usr/local/data/tmp/rootfs_list.tar.gz -C / >> $upgrade_log_file 2>&1
	rm -f /usr/local/data/tmp/rootfs_list.tar.gz
	echo "update rootfs"
fi

if [ 1 -eq $UPDATE_APP_FLAG ];then
	df / >> $upgrade_log_file 2>&1
	mv /usr/local/data/upgrade/app.tar.gz /usr/local/data/tmp/ >> $upgrade_log_file 2>&1
	md5sum /usr/local/data/tmp/app.tar.gz >> $upgrade_log_file
	sync;sync
	df / >> $upgrade_log_file 2>&1
	tar zxvf /usr/local/data/tmp/app.tar.gz -C /usr/local/ >> $upgrade_log_file 2>&1
	rm -f /usr/local/data/tmp/app.tar.gz
	cp /usr/local/app/driver/atcom_version.ko /usr/local/
	cp /usr/local/app/driver/atcom_lcd.ko /usr/local/
	echo "update app"
fi

if [ 1 -eq $UPDATE_RES_FLAG ];then
    mv /usr/local/data/upgrade/res.tar.gz /usr/local/data/tmp/
	rm -fr /usr/local/data/res
	tar zxvf /usr/local/data/tmp/res.tar.gz -C /usr/local/data/
	cp -f /usr/local/data/res/web/logo.gif /usr/local/app/lighttpd/www/htdocs/images/
	cp -fr /usr/local/data/res/web/css /usr/local/app/lighttpd/www/htdocs/
	cp -fr /usr/local/data/res/web/images /usr/local/app/lighttpd/www/htdocs/
	rm -f /usr/local/data/tmp/res.tar.gz
    echo "update res"
fi

if [ 1 -eq $UPDATE_CONFIG_FLAG ];then
	mv /usr/local/data/upgrade/config.tar.gz /usr/local/data/tmp/
	rm -fr /usr/local/data/configuration
	rm -fr /usr/local/app/configuration
	tar zxvf /usr/local/data/tmp/config.tar.gz -C /usr/local/data/
	tar zxvf /usr/local/data/tmp/config.tar.gz -C /usr/local/app/
	rm -f /usr/local/data/tmp/config.tar.gz
    echo "update config"
fi

if [ 1 -eq $UPDATE_APP_FLAG ] || [ 1 -eq $UPDATE_ROOTFS_FLAG ] || [ 1 -eq $UPDATE_RES_FLAG ] || [ 1 -eq $UPDATE_CONFIG_FLAG ]; then
	ISKINGLAND=`cat /usr/local/data/res/web/company_info.xml | grep kingland`
	if [ -n "$ISKINGLAND" ]; then
		echo "generate default config for kingland..."
		MACADDR=`ifconfig eth0 | awk '/HWaddr/{ print $5 }' | sed "s/://g"`
#		sed -i "s/Username.*/Username=JaN-$MACADDR/" /usr/local/data/configuration/Setting/Setting.cfg
#		sed -i "s/Password.*/Password=JaN-$MACADDR/" /usr/local/data/configuration/Setting/Setting.cfg
		sed -i "s/Username.*/Username=JaN-$MACADDR/" /usr/local/app/configuration/Setting/Setting.cfg
                sed -i "s/Password.*/Password=JaN-$MACADDR/" /usr/local/app/configuration/Setting/Setting.cfg
	fi
fi

SHOW_BOOTPROGRESS=yes
if [ 1 -eq $UPDATE_ROOTFS_FLAG ]; then
	/tmp/upgrade_fsync /boot >> $upgrade_log_file 2>&1
	/tmp/upgrade_fsync /bin >> $upgrade_log_file 2>&1
	/tmp/upgrade_fsync /sbin >> $upgrade_log_file 2>&1
	/tmp/upgrade_fsync /etc >> $upgrade_log_file 2>&1
	/tmp/upgrade_fsync /lib >> $upgrade_log_file 2>&1
	/tmp/upgrade_fsync /usr >> $upgrade_log_file 2>&1
	sync; sync; sync; sleep 10
	shutdown -r now
	sleep 30 
	shutdown -r now
	sleep 30 
	shutdown -r now
	sleep 30
	exit 0
fi
if [ 1 -eq $UPDATE_APP_FLAG ] || [ 1 -eq $UPDATE_RES_FLAG ] || [ 1 -eq $UPDATE_CONFIG_FLAG ]; then
	/tmp/upgrade_fsync /boot >> $upgrade_log_file 2>&1
	/tmp/upgrade_fsync /bin >> $upgrade_log_file 2>&1
	/tmp/upgrade_fsync /sbin >> $upgrade_log_file 2>&1
	/tmp/upgrade_fsync /etc >> $upgrade_log_file 2>&1
	/tmp/upgrade_fsync /lib >> $upgrade_log_file 2>&1
	/tmp/upgrade_fsync /usr >> $upgrade_log_file 2>&1
	sync; sync; sync; sleep 10
#	rmmod /usr/local/atcom_lcd.ko
#	rmmod /usr/local/atcom_version.ko
	shutdown -r now
	sleep 30
	shutdown -r now
	sleep 30
	shutdown -r now
	sleep 30
	exit 0
	SHOW_BOOTPROGRESS=no
fi

##################### start app
. /usr/local/app/initscript
